﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;

namespace BigBlueButtonSDK
{
    public class GetDefaultConfigXMLRequest  : BaseRequest
    {
        public GetDefaultConfigXMLRequest()
        {
            this._methodName = "getDefaultConfigXML";
            this._response = new GetDefaultConfigXMLResponse();
        }

        public new GetDefaultConfigXMLResponse Execute()
        {
            return (GetDefaultConfigXMLResponse)base.Execute();
        }
    }

    public class GetDefaultConfigXMLResponse : BaseResponse
    {
        private XmlDocument _xmlResponse;
        public XmlDocument XmlResponse
        {
            get
            {
                if (!String.IsNullOrEmpty(this.Response))
                {
                    _xmlResponse = new XmlDocument();
                    _xmlResponse.LoadXml(this.Response);
                }
                return _xmlResponse;
            }
        }
    }

    public class GetDefaultConfigXML
    {
        private GetDefaultConfigXMLRequest _request;
        [CategoryAttribute("Get Meeting Info Request")]
        [TypeConverter(typeof(ExpandableObjectConverter))]
        [DisplayName("Get Meeting Info request")]
        public GetDefaultConfigXMLRequest Request
        {
            get { return _request; }
            set { _request = value; }
        }

        private GetDefaultConfigXMLResponse _response;
        [CategoryAttribute("Get Meeting Info Response")]
        [DisplayName("Get Meeting Info response")]
        [TypeConverter(typeof(ExpandableObjectConverter))]
        public GetDefaultConfigXMLResponse Response
        {
            get { return _response; }
            set { _response = value; }
        }
    }
}
