﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace BigBlueButtonSDK
{
    public class BigBlueButton
    {
        public static CreateMeetingResponse CreateMeeting(CreateMeetingRequest request)
        {
            if (request != null)
                return request.Execute();
            else
                return null;
        }

        public static JoinMeetingResponse JoinMeeting(JoinMeetingRequest request, bool IsOpenBrowser = false)
        {
            if (request != null)
            {
                JoinMeetingResponse response = request.Execute();
                if (IsOpenBrowser && response.Response.Length > 0) //if everything is ok
                    Process.Start(request.RequestURL);
                return response;
            }
            else
                return null;
        }

        public static bool isMeetingRunning(string ServerURL, string SecuritySalt, string MeetingID)
        {
            IsMeetingRunningRequest request = new IsMeetingRunningRequest();
            request.ServerURL = ServerURL;
            request.SecuritySalt = SecuritySalt;
            request.MeetingID = MeetingID;
            IsMeetingRunningResponse response = request.Execute();
            return response.IsRunning;
        }
    }
}
