﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

/// <summary>
/// This project is developed by Andrey A. Fedorov from BizKit.ru.
/// E-mail me at fedorov@bizkit.ru for any support on this code or even support on BigBlueButton.
/// </summary>
namespace BigBlueButtonSDK
{
    public class General
    {
        public static DateTime MillisecondsToDateTime(double milliseconds)
        {
            DateTime posixTime = DateTime.SpecifyKind(new DateTime(1970, 1, 1), DateTimeKind.Utc);
            return posixTime.AddMilliseconds(milliseconds);
        }

        public static string GetSHA1(string strToEncryp)
        {
            System.Text.UTF8Encoding ue = new System.Text.UTF8Encoding();
            byte[] bytes = ue.GetBytes(strToEncryp);

            // encrypt bytes
            SHA1CryptoServiceProvider SHA = new SHA1CryptoServiceProvider();
            byte[] hashBytes = SHA.ComputeHash(bytes);

            // Convert the encrypted bytes back to a string (base 16)
            string hashString = "";

            for (int i = 0; i < hashBytes.Length; i++)
            {
                hashString += Convert.ToString(hashBytes[i], 16).PadLeft(2, '0');
            }

            return hashString.PadLeft(32, '0');
        }

        public static DateTime MillisecondsToDateTime(string milliseconds)
        {
            if (!String.IsNullOrEmpty(milliseconds))
            {
                double ms = 0;
                if (double.TryParse(milliseconds, out ms))
                {
                    return MillisecondsToDateTime(ms);
                }
            }
            return DateTime.MinValue;
        }

        public static string DateTimeToMilliseconds(DateTime date)
        {
            double mills = date.ToUniversalTime().Subtract(new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).TotalMilliseconds;
            return mills.ToString();
        }
    }
}
