﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using BigBlueButtonSDK;
using System.Diagnostics;

namespace BigBlueButtonVerify
{
    public partial class BigBlueButton : Form
    {
        public enum Functions { CreateMeeting = 0, JoinMeeting = 1, IsMeetingRunning = 2, EndMeeting = 3, GetMeetingInfo = 4, GetDefaultConfigXML = 5, GetMeetings = 6, GetRecordings = 7 };

        CreateMeeting createMeeting = new CreateMeeting();
        CreateMeetingRequest createRequest = new CreateMeetingRequest();
        CreateMeetingResponse createResponse = new CreateMeetingResponse();

        JoinMeeting joinMeeting = new JoinMeeting();
        JoinMeetingRequest joinRequest = new JoinMeetingRequest();
        JoinMeetingResponse joinResponse = new JoinMeetingResponse();

        IsMeetingRunning isMeetingRunning = new IsMeetingRunning();
        IsMeetingRunningRequest isMeetingRunningRequest = new IsMeetingRunningRequest();
        IsMeetingRunningResponse isMeetingRunningResponse = new IsMeetingRunningResponse();

        EndMeeting endMeeting = new EndMeeting();
        EndMeetingRequest endMeetingRequest = new EndMeetingRequest();
        EndMeetingResponse endMeetingResponse = new EndMeetingResponse();

        GetMeetingInfo getMeetingInfo = new GetMeetingInfo();
        GetMeetingInfoRequest getMeetingInfoRequest = new GetMeetingInfoRequest();
        GetMeetingInfoResponse getMeetingInfoResponse = new GetMeetingInfoResponse();

        GetDefaultConfigXML getDefaultConfigXML = new GetDefaultConfigXML();
        GetDefaultConfigXMLRequest getDefaultConfigXMLRequest = new GetDefaultConfigXMLRequest();
        GetDefaultConfigXMLResponse getDefaultConfigXMLResponse = new GetDefaultConfigXMLResponse();

        GetMeetings getMeetings = new GetMeetings();
        GetMeetingsRequest getMeetingsRequest = new GetMeetingsRequest();
        GetMeetingsResponse getMeetingsResponse = new GetMeetingsResponse();

        GetRecordings getRecordings = new GetRecordings();
        GetRecordingsRequest getRecordingsRequest = new GetRecordingsRequest();
        GetRecordingsResponse getRecordingsResponse = new GetRecordingsResponse();

        public BigBlueButton()
        {
            InitializeComponent();
            foreach (Functions foo in Enum.GetValues(typeof(Functions)))
            {
                tbFunctionSelector.Items.Add(foo.ToString());
            }

            tbFunctionSelector.SelectedIndex = (int)Functions.CreateMeeting;
        }

        private void FillDefaultCreateMeetingRequestAndResponse()
        {
            createRequest.ServerURL = tbBigBlueButtonServer.Text;
            createRequest.SecuritySalt = tbSalt.Text;
            createRequest.Name = "Debugging";
            createRequest.ModeratorPassword = "123456";
            createRequest.AttendeePassword = "654321";
            //createRequest.AllowStartStopRecording = true;
            //createRequest.LogoutURL = "http://news.ridan.local/bigbluebutton";
            createRequest.MeetingID = "e0ae6dfb996a0e0ea85bd7a47359bfc994d646ee";

            createResponse.Response = @"    <response> 
        <returncode>SUCCESS</returncode> 
        <meeting> 
            <meetingID>Test</meetingID> 
            <createTime>1308591802</createTime> 
            <attendeePW>ap</attendeePW> 
            <moderatorPW>mp</moderatorPW> 
            <hasBeenForciblyEnded>false</hasBeenForciblyEnded> 
            <messageKey>createSuccess</messageKey> 
            <message>Meeting has been create</message> 
        </meeting> 
    </response> ";

        }

        private void FillDefaultJoinMeetingRequestAndResponse()
        {
            joinRequest.MeetingID = "e0ae6dfb996a0e0ea85bd7a47359bfc994d646ee";
            joinRequest.FullName = "Andrey Fedorov";
            joinRequest.ServerURL = tbBigBlueButtonServer.Text;
            joinRequest.SecuritySalt = tbSalt.Text;
            joinRequest.Password = "123456";
        }

        private void FillDefaultIsMeetingRunningRequestAndResponse()
        {
            isMeetingRunningRequest.MeetingID = "e0ae6dfb996a0e0ea85bd7a47359bfc994d646ee";
            isMeetingRunningRequest.ServerURL = tbBigBlueButtonServer.Text;
            isMeetingRunningRequest.SecuritySalt = tbSalt.Text;
        }

        private void FillDefaultEndMeetingRequestAndResponse()
        {
            endMeetingRequest.MeetingID = "e0ae6dfb996a0e0ea85bd7a47359bfc994d646ee";
            endMeetingRequest.Password = "123456";
            endMeetingRequest.ServerURL = tbBigBlueButtonServer.Text;
            endMeetingRequest.SecuritySalt = tbSalt.Text;
        }

        private void FillDefaultGetMeetingInfoRequestAndResponse()
        {
            getMeetingInfoRequest.MeetingID = "e0ae6dfb996a0e0ea85bd7a47359bfc994d646ee";
            getMeetingInfoRequest.Password = "123456";
            getMeetingInfoRequest.ServerURL = tbBigBlueButtonServer.Text;
            getMeetingInfoRequest.SecuritySalt = tbSalt.Text;
        }

        private void FillDefaultGetDefaultConfigXMLRequestAndResponse()
        {
            getDefaultConfigXMLRequest.ServerURL = tbBigBlueButtonServer.Text;
            getDefaultConfigXMLRequest.SecuritySalt = tbSalt.Text;
        }

        private void FillGetMeetingsRequestAndResponse()
        {
            getMeetingsRequest.ServerURL = tbBigBlueButtonServer.Text;
            getMeetingsRequest.SecuritySalt = tbSalt.Text;
        }

        public void FillGetRecordsRequestAndResponse()
        {
            getRecordingsRequest.MeetingID = "e0ae6dfb996a0e0ea85bd7a47359bfc994d646ee";
            getRecordingsRequest.ServerURL = tbBigBlueButtonServer.Text;
            getRecordingsRequest.SecuritySalt = tbSalt.Text;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //BaseResponse response = new BaseResponse(tbVerify.Text);
            //GetMeetingInfo info = new GetMeetingInfo();
            ////info.Response = tbVerify.Text;
            ////DateTime dt = info.StartTime;
        }

        private void tbVerify_TextChanged(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            Functions func = (Functions)tbFunctionSelector.SelectedIndex;
            switch (func)
            {
                case Functions.CreateMeeting:
                    createMeeting.Response = createRequest.Execute();
                    pgCreateMeeting.SelectedObject = createMeeting;
                    break;
                case Functions.JoinMeeting:
                    joinResponse = joinRequest.Execute();
                    if (joinResponse.Response.Length > 0) //if everything is ok
                    {
                        Process.Start(joinRequest.RequestURL);
                        joinMeeting.Response = null;
                    }
                    else //if something goes wrong
                        joinMeeting.Response = joinResponse;
                    pgCreateMeeting.SelectedObject = joinResponse; 
                    break;
                case Functions.IsMeetingRunning:
                    isMeetingRunning.Response = isMeetingRunningRequest.Execute();
                    pgCreateMeeting.SelectedObject = isMeetingRunning;
                    break;
                case Functions.EndMeeting:
                    endMeeting.Response = endMeetingRequest.Execute();
                    pgCreateMeeting.SelectedObject = endMeeting;
                    break;
                case Functions.GetMeetingInfo:
                    getMeetingInfo.Response = getMeetingInfoRequest.Execute();
                    pgCreateMeeting.SelectedObject = getMeetingInfo;
                    break;
                case Functions.GetDefaultConfigXML:
                    getDefaultConfigXML.Response = getDefaultConfigXMLRequest.Execute();
                    pgCreateMeeting.SelectedObject = getDefaultConfigXML;
                    break;
                case Functions.GetMeetings:
                    getMeetings.Response = getMeetingsRequest.Execute();
                    pgCreateMeeting.SelectedObject = getMeetings;
                    break;
            
                case Functions.GetRecordings:
                    getRecordings.Response = getRecordingsRequest.Execute();
                    pgCreateMeeting.SelectedObject = getRecordings;
                    break;
            }
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            Functions func = (Functions)tbFunctionSelector.SelectedIndex;
            switch (func)
            {
                case Functions.CreateMeeting:
                    pgCreateMeeting.SelectedObject = createMeeting;
                    FillDefaultCreateMeetingRequestAndResponse();
                    createMeeting.Request = createRequest;
                    createMeeting.Response = createResponse;
                    break;
                case Functions.JoinMeeting:
                    pgCreateMeeting.SelectedObject = joinMeeting;
                    FillDefaultJoinMeetingRequestAndResponse();
                    joinMeeting.Request = joinRequest;
                    joinMeeting.Response = joinResponse;
                    break;
                case Functions.IsMeetingRunning:
                    pgCreateMeeting.SelectedObject = isMeetingRunning;
                    FillDefaultIsMeetingRunningRequestAndResponse();
                    isMeetingRunning.Request = isMeetingRunningRequest;
                    isMeetingRunning.Response = isMeetingRunningResponse;
                    break;
                case Functions.EndMeeting:
                    pgCreateMeeting.SelectedObject = endMeeting;
                    FillDefaultEndMeetingRequestAndResponse();
                    endMeeting.Request = endMeetingRequest;
                    endMeeting.Response = endMeetingResponse;
                    break;
                case Functions.GetMeetingInfo:
                    pgCreateMeeting.SelectedObject = getMeetingInfo;
                    FillDefaultGetMeetingInfoRequestAndResponse();
                    getMeetingInfo.Request = getMeetingInfoRequest;
                    getMeetingInfo.Response = getMeetingInfoResponse;
                    break;
                case Functions.GetDefaultConfigXML:
                    pgCreateMeeting.SelectedObject = getDefaultConfigXML;
                    FillDefaultGetDefaultConfigXMLRequestAndResponse();
                    getDefaultConfigXML.Request = getDefaultConfigXMLRequest;
                    getDefaultConfigXML.Response = getDefaultConfigXMLResponse;
                    break;
                case Functions.GetMeetings:
                    pgCreateMeeting.SelectedObject = getMeetings;
                    FillGetMeetingsRequestAndResponse();
                    getMeetings.Request = getMeetingsRequest;
                    getMeetings.Response = getMeetingsResponse;
                    break;
                case Functions.GetRecordings:
                    pgCreateMeeting.SelectedObject = getRecordings;
                    FillGetRecordsRequestAndResponse();
                    getRecordings.Request = getRecordingsRequest;
                    getRecordings.Response = getRecordingsResponse;
                    break;
            }
            pgCreateMeeting.ExpandAllGridItems();
        }
    }




}
